import java.util.Scanner;


public class Zadatak2 {

   
    public static void main(String[] args) {
     int N=0,O,A,B,AB,i=0,m,op,ap,bp,abp,brojac=0;
     String s="";
     Scanner in=new Scanner(System.in);
     N=in.nextInt();
     if(N<-1 || N>10000){
         System.exit(1);
     }
     else{
     String grupe[]=new String[N];
     int kolicine[]=new int[N];
     String ispis[]=new String[N];
     O=in.nextInt();
     A=in.nextInt();
     B=in.nextInt();
     AB=in.nextInt();
    for(i=0;i<N;i++){
      grupe[i]=in.next();
      kolicine[i]=in.nextInt();   
    }
for(i=0;i<N;i++){
    s=grupe[i];
    m=kolicine[i];
    if(s.equals("O")){
     if(O!=0){
       if(O>m || O==m){
          op=m;
          O=O-m;
           ispis[i]=op+" 0 0 0";
           brojac++;
       }
      
         
     }   
    }
    if(s.equals("A")){
        if(A!=0){
            if(A>m || A==m){
                ap=m;
                A=A-m;
                ispis[i]="0"+ap+"0 0";
                brojac++;
            }
            else{
                if(O!=0 && m-A<O){
                    ap=m;
                    op=(m-A)-O;
                    O=O-(m-A);
                    A=0;
                    ispis[i]=op+ap+" 0 0";
                    brojac++;
                }
            }
        }
        else if(O!=0){
          op=m;
          O=O-m;
           ispis[i]=op+" 0 0 0";
           brojac++;
        }
        
       
    }
    if(s.equals("B")){
        if(B!=0){
            if(B>m || B==m){
                bp=m;
                B=B-m;
                ispis[i]="0 0 "+bp+" 0";
                brojac++;
            }
            else{
                if(O!=0 && m-B<O){
                    bp=m;
                    op=(m-B)-O;
                    O=O-(m-B);
                    B=0;
                    ispis[i]=op+"0 "+bp+" 0";
                    brojac++;
                }
            }
        }
        else if(O!=0){
          op=m;
          O=O-m;
           ispis[i]=op+" 0 0 0";
           brojac++;
        }
        
    }
    if(s.equals("AB")){
        if(AB!=0){
            if(AB>m || AB==m){
                abp=m;
                AB=AB-m;
               ispis[i]="0 0 0 "+abp;
               brojac++;
            }
            else{
                if(O!=0){
                    abp=AB;
                    op=(m-AB);
                    O=O-(m-AB);
                    ispis[i]=op+" 0 0 "+abp;
                    brojac++;
                }
                else if(A!=0){
                    abp=AB;
                    ap=(m-AB);
                    A=A-(m-AB);
                   ispis[i]="0 "+ap+" 0 "+abp;
                   brojac++;
                }
                else if(B!=0){
                    abp=AB;
                    bp=(m-AB);
                    B=B-(m-AB);
                    ispis[i]="0 0 "+bp+""+abp;
                    brojac++;
                }
            }
        }
        if(AB==0){
            if(O!=0){
                if(O>m || O==m){
                    op=m;
                    O=O-m;
                    ispis[i]=op+" 0 0 0";
                    brojac++;
                }
                else if(A !=0 && A>=(m-O)){
                    op=O;
                    ap=(m-O);
                    A=A-(m-O);
                    ispis[i]=op+""+ap+" 0 0";
                    brojac++;
                }
                else if(B!=0 && B>=(m-O)){
                    op=O;
                    bp=m-O;
                    B=B-(m-O);
                    ispis[i]=op+" 0"+bp+" 0";
                    brojac++;
                }
            }
            else if(A!=0){
                if(A>=m){
                    ap=m;
                    A=A-m;
                    ispis[i]="0 "+ap+" 0 0";
                    brojac++;
                }
                else if(B>=(m-A)){
                    ap=A;
                    bp=m-A;
                    B=B-(m-A);
                    ispis[i]="0"+ap+""+bp+" 0";
                    brojac++;
                }
            }
        }
       
    }
   
}
 if(brojac==N){
        System.out.println("moguce");
        for(i=0;i<N;i++){
            System.out.println(ispis[i]);
        }
    }
      else{
               System.out.println("nemoguce");
                }
     }
 
    }
}